/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MSG
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_msg.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static void *
alloc_msgs()
{
	return xcalloc(NMSGS, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + NMSGS; p++) {
		bi_close_message(p);
	}
	free(mtab);
}


#line 36

#line 36
static int MSGTAB_id;
#line 36 "bi_msg.m4"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 111


#line 122


#line 133


/* void message_close(number msg) */
void
#line 136
bi_message_close(eval_environ_t env)
#line 136

#line 136 "bi_msg.m4"
{
#line 136
	
#line 136

#line 136

#line 136
long  nmsg;
#line 136
        
#line 136
get_numeric_arg(env, 0, &nmsg);
#line 136
        
#line 136

#line 136
        adjust_stack(env, 1);
#line 136

#line 136
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 136
		prog_trace(env, "message_close %lu",nmsg);;
#line 136

{
	
#line 138
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 138
	struct mf_message *mp;
#line 138
			
#line 138
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 138
			env_throw_bi(env, mfe_range, "message_close", _("Invalid message descriptor"))
#line 138
;
#line 138
	mp = mtab + nmsg;
#line 138
		if (!(mp->msg))
#line 138
			env_throw_bi(env, mfe_failure, "message_close", _("Message not open"))
#line 138

#line 138
;
	bi_close_message(mp);
}
}

/* number message_size(number nmsg) */
void
#line 144
bi_message_size(eval_environ_t env)
#line 144

#line 144 "bi_msg.m4"
{
#line 144
	
#line 144

#line 144

#line 144
long  nmsg;
#line 144
        
#line 144
get_numeric_arg(env, 0, &nmsg);
#line 144
        
#line 144

#line 144
        adjust_stack(env, 1);
#line 144

#line 144
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 144
		prog_trace(env, "message_size %lu",nmsg);;
#line 144

{
	int rc;
	size_t size;
	
#line 148
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 148
	struct mf_message *mp;
#line 148
			
#line 148
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 148
			env_throw_bi(env, mfe_range, "message_size", _("Invalid message descriptor"))
#line 148
;
#line 148
	mp = mtab + nmsg;
#line 148
		if (!(mp->msg))
#line 148
			env_throw_bi(env, mfe_failure, "message_size", _("Message not open"))
#line 148

#line 148
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 151
			env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 153
;
		if (!(size < LONG_MAX))
#line 154
			env_throw_bi(env, mfe_range, "message_size", _("Message size out of representable range"))
#line 156
;
	
#line 157
do {
#line 157
  push(env, (STKVAL) ((long)size));
#line 157
  return;
#line 157
} while (0);
}	
}

/* number message_lines(number nmsg) */
void
#line 162
bi_message_lines(eval_environ_t env)
#line 162

#line 162 "bi_msg.m4"
{
#line 162
	
#line 162

#line 162

#line 162
long  nmsg;
#line 162
        
#line 162
get_numeric_arg(env, 0, &nmsg);
#line 162
        
#line 162

#line 162
        adjust_stack(env, 1);
#line 162

#line 162
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 162
		prog_trace(env, "message_lines %lu",nmsg);;
#line 162

{
	int rc;
	size_t lines;
	
#line 166
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 166
	struct mf_message *mp;
#line 166
			
#line 166
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 166
			env_throw_bi(env, mfe_range, "message_lines", _("Invalid message descriptor"))
#line 166
;
#line 166
	mp = mtab + nmsg;
#line 166
		if (!(mp->msg))
#line 166
			env_throw_bi(env, mfe_failure, "message_lines", _("Message not open"))
#line 166

#line 166
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 169
			env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 172
;
	
#line 173
do {
#line 173
  push(env, (STKVAL) (lines));
#line 173
  return;
#line 173
} while (0);
}
}

/* number message_body_size(number nmsg) */
void
#line 178
bi_message_body_size(eval_environ_t env)
#line 178

#line 178 "bi_msg.m4"
{
#line 178
	
#line 178

#line 178

#line 178
long  nmsg;
#line 178
        
#line 178
get_numeric_arg(env, 0, &nmsg);
#line 178
        
#line 178

#line 178
        adjust_stack(env, 1);
#line 178

#line 178
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 178
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 178

{
	int rc;
	size_t size;
	
#line 182
	
#line 182
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 182
	struct mf_message *mp;
#line 182
			
#line 182
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 182
			env_throw_bi(env, mfe_range, "message_body_size", _("Invalid message descriptor"))
#line 182
;
#line 182
	mp = mtab + nmsg;
#line 182
		if (!(mp->msg))
#line 182
			env_throw_bi(env, mfe_failure, "message_body_size", _("Message not open"))
#line 182

#line 182
;
#line 182
	if (!mp->body) {
#line 182
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 182
			if (!(rc == 0))
#line 182
			env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 182
;
#line 182
	}	  
#line 182
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 185
			env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 187
;
		if (!(size < LONG_MAX))
#line 188
			env_throw_bi(env, mfe_range, "message_body_size", _("Body size out of representable range"))
#line 190
;
	
#line 191
do {
#line 191
  push(env, (STKVAL) ((long)size));
#line 191
  return;
#line 191
} while (0);
}
}

/* number message_body_lines(number nmsg) */
void
#line 196
bi_message_body_lines(eval_environ_t env)
#line 196

#line 196 "bi_msg.m4"
{
#line 196
	
#line 196

#line 196

#line 196
long  nmsg;
#line 196
        
#line 196
get_numeric_arg(env, 0, &nmsg);
#line 196
        
#line 196

#line 196
        adjust_stack(env, 1);
#line 196

#line 196
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 196
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 196

{
	int rc;
	size_t lines;
	
#line 200
	
#line 200
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 200
	struct mf_message *mp;
#line 200
			
#line 200
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 200
			env_throw_bi(env, mfe_range, "message_body_lines", _("Invalid message descriptor"))
#line 200
;
#line 200
	mp = mtab + nmsg;
#line 200
		if (!(mp->msg))
#line 200
			env_throw_bi(env, mfe_failure, "message_body_lines", _("Message not open"))
#line 200

#line 200
;
#line 200
	if (!mp->body) {
#line 200
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 200
			if (!(rc == 0))
#line 200
			env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 200
;
#line 200
	}	  
#line 200
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 203
			env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 206
;
	
#line 207
do {
#line 207
  push(env, (STKVAL) (lines));
#line 207
  return;
#line 207
} while (0);
}
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 215
bi_message_header_size(eval_environ_t env)
#line 215

#line 215 "bi_msg.m4"
{
#line 215
	
#line 215

#line 215

#line 215
long  nmsg;
#line 215
        
#line 215
get_numeric_arg(env, 0, &nmsg);
#line 215
        
#line 215

#line 215
        adjust_stack(env, 1);
#line 215

#line 215
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 215
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 215

{
	int rc;
	size_t size;
	
#line 219
	
#line 219
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 219
	struct mf_message *mp;
#line 219
			
#line 219
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 219
			env_throw_bi(env, mfe_range, "message_header_size", _("Invalid message descriptor"))
#line 219
;
#line 219
	mp = mtab + nmsg;
#line 219
		if (!(mp->msg))
#line 219
			env_throw_bi(env, mfe_failure, "message_header_size", _("Message not open"))
#line 219

#line 219
;
#line 219
	if (!mp->hdr) {
#line 219
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 219
			if (!(rc == 0))
#line 219
			env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 219
;
#line 219
	}	  
#line 219
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 222
			env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 224
;
		if (!(size < LONG_MAX))
#line 225
			env_throw_bi(env, mfe_range, "message_header_size", _("Header size out of representable range"))
#line 227
;
	
#line 228
do {
#line 228
  push(env, (STKVAL) ((long)size));
#line 228
  return;
#line 228
} while (0);
}
}

/* number message_header_lines(number nmsg) */
void
#line 233
bi_message_header_lines(eval_environ_t env)
#line 233

#line 233 "bi_msg.m4"
{
#line 233
	
#line 233

#line 233

#line 233
long  nmsg;
#line 233
        
#line 233
get_numeric_arg(env, 0, &nmsg);
#line 233
        
#line 233

#line 233
        adjust_stack(env, 1);
#line 233

#line 233
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 233
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 233

{
	int rc;
	size_t lines;
	
#line 237
	
#line 237
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 237
	struct mf_message *mp;
#line 237
			
#line 237
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 237
			env_throw_bi(env, mfe_range, "message_header_lines", _("Invalid message descriptor"))
#line 237
;
#line 237
	mp = mtab + nmsg;
#line 237
		if (!(mp->msg))
#line 237
			env_throw_bi(env, mfe_failure, "message_header_lines", _("Message not open"))
#line 237

#line 237
;
#line 237
	if (!mp->hdr) {
#line 237
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 237
			if (!(rc == 0))
#line 237
			env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 237
;
#line 237
	}	  
#line 237
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 240
			env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 243
;
	
#line 244
do {
#line 244
  push(env, (STKVAL) (lines));
#line 244
  return;
#line 244
} while (0);
}
}

/* number message_header_count(number nmsg) */
void
#line 249
bi_message_header_count(eval_environ_t env)
#line 249

#line 249 "bi_msg.m4"
{
#line 249
	
#line 249

#line 249

#line 249
long  nmsg;
#line 249
        
#line 249
get_numeric_arg(env, 0, &nmsg);
#line 249
        
#line 249

#line 249
        adjust_stack(env, 1);
#line 249

#line 249
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 249
		prog_trace(env, "message_header_count %lu",nmsg);;
#line 249

{
	int rc;
	size_t count;
	
#line 253
	
#line 253
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 253
	struct mf_message *mp;
#line 253
			
#line 253
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 253
			env_throw_bi(env, mfe_range, "message_header_count", _("Invalid message descriptor"))
#line 253
;
#line 253
	mp = mtab + nmsg;
#line 253
		if (!(mp->msg))
#line 253
			env_throw_bi(env, mfe_failure, "message_header_count", _("Message not open"))
#line 253

#line 253
;
#line 253
	if (!mp->hdr) {
#line 253
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 253
			if (!(rc == 0))
#line 253
			env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 253
;
#line 253
	}	  
#line 253
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 256
			env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 259
;
	
#line 260
do {
#line 260
  push(env, (STKVAL) (count));
#line 260
  return;
#line 260
} while (0);
}
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 265
bi_message_has_header(eval_environ_t env)
#line 265

#line 265 "bi_msg.m4"
{
#line 265
	
#line 265

#line 265
long __bi_argcnt;
#line 265
long  nmsg;
#line 265
        char * header;
#line 265
        long  idx;
#line 265
        
#line 265
get_numeric_arg(env, 1, &nmsg);
#line 265
        get_string_arg(env, 2, &header);
#line 265
        get_numeric_arg(env, 3, &idx);
#line 265
        
#line 265
get_numeric_arg(env, 0, &__bi_argcnt);
#line 265
        adjust_stack(env, __bi_argcnt + 1);
#line 265

#line 265
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 265
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 270
	
#line 270
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 270
	struct mf_message *mp;
#line 270
			
#line 270
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 270
			env_throw_bi(env, mfe_range, "message_has_header", _("Invalid message descriptor"))
#line 270
;
#line 270
	mp = mtab + nmsg;
#line 270
		if (!(mp->msg))
#line 270
			env_throw_bi(env, mfe_failure, "message_has_header", _("Message not open"))
#line 270

#line 270
;
#line 270
	if (!mp->hdr) {
#line 270
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 270
			if (!(rc == 0))
#line 270
			env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 270
;
#line 270
	}	  
#line 270
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 273
do {
#line 273
  push(env, (STKVAL) (rc == 0));
#line 273
  return;
#line 273
} while (0);
}
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 278
bi_message_find_header(eval_environ_t env)
#line 278

#line 278 "bi_msg.m4"
{
#line 278
	
#line 278

#line 278
long __bi_argcnt;
#line 278
long  nmsg;
#line 278
        char * header;
#line 278
        long  idx;
#line 278
        
#line 278
get_numeric_arg(env, 1, &nmsg);
#line 278
        get_string_arg(env, 2, &header);
#line 278
        get_numeric_arg(env, 3, &idx);
#line 278
        
#line 278
get_numeric_arg(env, 0, &__bi_argcnt);
#line 278
        adjust_stack(env, __bi_argcnt + 1);
#line 278

#line 278
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 278
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 283
	
#line 283
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 283
	struct mf_message *mp;
#line 283
			
#line 283
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 283
			env_throw_bi(env, mfe_range, "message_find_header", _("Invalid message descriptor"))
#line 283
;
#line 283
	mp = mtab + nmsg;
#line 283
		if (!(mp->msg))
#line 283
			env_throw_bi(env, mfe_failure, "message_find_header", _("Message not open"))
#line 283

#line 283
;
#line 283
	if (!mp->hdr) {
#line 283
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 283
			if (!(rc == 0))
#line 283
			env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 283
;
#line 283
	}	  
#line 283
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "message_find_header", _("Header not found"));
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 290
return;
#line 290
} while (0);
}
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 298
bi_message_is_multipart(eval_environ_t env)
#line 298

#line 298 "bi_msg.m4"
{
#line 298
	
#line 298

#line 298

#line 298
long  nmsg;
#line 298
        
#line 298
get_numeric_arg(env, 0, &nmsg);
#line 298
        
#line 298

#line 298
        adjust_stack(env, 1);
#line 298

#line 298
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 298
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 298

{
	int rc, res;
	
#line 301
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 301
	struct mf_message *mp;
#line 301
			
#line 301
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 301
			env_throw_bi(env, mfe_range, "message_is_multipart", _("Invalid message descriptor"))
#line 301
;
#line 301
	mp = mtab + nmsg;
#line 301
		if (!(mp->msg))
#line 301
			env_throw_bi(env, mfe_failure, "message_is_multipart", _("Message not open"))
#line 301

#line 301
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 304
			env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 307
;
	
#line 308
do {
#line 308
  push(env, (STKVAL) (res));
#line 308
  return;
#line 308
} while (0);
}
}

/* number message_count_parts(number msg) */
void
#line 313
bi_message_count_parts(eval_environ_t env)
#line 313

#line 313 "bi_msg.m4"
{
#line 313
	
#line 313

#line 313

#line 313
long  nmsg;
#line 313
        
#line 313
get_numeric_arg(env, 0, &nmsg);
#line 313
        
#line 313

#line 313
        adjust_stack(env, 1);
#line 313

#line 313
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 313
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 313

{
	int rc;
	size_t count;
	
#line 317
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 317
	struct mf_message *mp;
#line 317
			
#line 317
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 317
			env_throw_bi(env, mfe_range, "message_count_parts", _("Invalid message descriptor"))
#line 317
;
#line 317
	mp = mtab + nmsg;
#line 317
		if (!(mp->msg))
#line 317
			env_throw_bi(env, mfe_failure, "message_count_parts", _("Message not open"))
#line 317

#line 317
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 319
			env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 322
;
	
#line 323
do {
#line 323
  push(env, (STKVAL) (count));
#line 323
  return;
#line 323
} while (0);
}
}

/* number message_get_part(number msg, number idx) */
void
#line 328
bi_message_get_part(eval_environ_t env)
#line 328

#line 328 "bi_msg.m4"
{
#line 328
	
#line 328

#line 328

#line 328
long  nmsg;
#line 328
        long  idx;
#line 328
        
#line 328
get_numeric_arg(env, 0, &nmsg);
#line 328
        get_numeric_arg(env, 1, &idx);
#line 328
        
#line 328

#line 328
        adjust_stack(env, 2);
#line 328

#line 328
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 328
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 328

{
	int rc;
	mu_message_t msg;
	
#line 332
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 332
	struct mf_message *mp;
#line 332
			
#line 332
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 332
			env_throw_bi(env, mfe_range, "message_get_part", _("Invalid message descriptor"))
#line 332
;
#line 332
	mp = mtab + nmsg;
#line 332
		if (!(mp->msg))
#line 332
			env_throw_bi(env, mfe_failure, "message_get_part", _("Message not open"))
#line 332

#line 332
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 335
			env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 338
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 340
			env_throw_bi(env, mfe_failure, "message_get_part", _("No more message slots available"))
#line 342
;
	
#line 343
do {
#line 343
  push(env, (STKVAL) (rc));
#line 343
  return;
#line 343
} while (0);
}
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 351
bi_message_rewind(eval_environ_t env)
#line 351

#line 351 "bi_msg.m4"
{
#line 351
	
#line 351

#line 351

#line 351
long  nmsg;
#line 351
        
#line 351
get_numeric_arg(env, 0, &nmsg);
#line 351
        
#line 351

#line 351
        adjust_stack(env, 1);
#line 351

#line 351
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 351
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 351

{
	int rc;
	mu_stream_t str;
	
#line 355
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 355
	struct mf_message *mp;
#line 355
			
#line 355
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 355
			env_throw_bi(env, mfe_range, "message_rewind", _("Invalid message descriptor"))
#line 355
;
#line 355
	mp = mtab + nmsg;
#line 355
		if (!(mp->msg))
#line 355
			env_throw_bi(env, mfe_failure, "message_rewind", _("Message not open"))
#line 355

#line 355
;
	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 357
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 360
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 362
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 365
;
}
}

/* string message_read_line(number nmsg) */
void
#line 370
bi_message_read_line(eval_environ_t env)
#line 370

#line 370 "bi_msg.m4"
{
#line 370
	
#line 370

#line 370

#line 370
long  nmsg;
#line 370
        
#line 370
get_numeric_arg(env, 0, &nmsg);
#line 370
        
#line 370

#line 370
        adjust_stack(env, 1);
#line 370

#line 370
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 370
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 370

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 375
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 375
	struct mf_message *mp;
#line 375
			
#line 375
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 375
			env_throw_bi(env, mfe_range, "message_read_line", _("Invalid message descriptor"))
#line 375
;
#line 375
	mp = mtab + nmsg;
#line 375
		if (!(mp->msg))
#line 375
			env_throw_bi(env, mfe_failure, "message_read_line", _("Message not open"))
#line 375

#line 375
;

	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 378
			env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 381
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 383
			env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 386
;
		if (!(size > 0))
#line 387
			env_throw_bi(env, mfe_not_found, "message_read_line", /* FIXME: Should be mfe_eof */
		  "mu_stream_sequential_getline: %s",_("end of input"))
#line 390
;
	do {pushs(env, mp->buf);
#line 391
return;
#line 391
} while (0);
}
}

/* string message_body_rewind(number nmsg) */
void
#line 396
bi_message_body_rewind(eval_environ_t env)
#line 396

#line 396 "bi_msg.m4"
{
#line 396
	
#line 396

#line 396

#line 396
long  nmsg;
#line 396
        
#line 396
get_numeric_arg(env, 0, &nmsg);
#line 396
        
#line 396

#line 396
        adjust_stack(env, 1);
#line 396

#line 396
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 396
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 396

{
	int rc;
	mu_stream_t str;
	
#line 400
	
#line 400
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 400
	struct mf_message *mp;
#line 400
			
#line 400
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 400
			env_throw_bi(env, mfe_range, "message_body_rewind", _("Invalid message descriptor"))
#line 400
;
#line 400
	mp = mtab + nmsg;
#line 400
		if (!(mp->msg))
#line 400
			env_throw_bi(env, mfe_failure, "message_body_rewind", _("Message not open"))
#line 400

#line 400
;
#line 400
	if (!mp->body) {
#line 400
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 400
			if (!(rc == 0))
#line 400
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 400
;
#line 400
	}	  
#line 400
;
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 402
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 405
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 407
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 410
;
}
}

/* string message_read_body_line(number msg)  */
void
#line 415
bi_message_read_body_line(eval_environ_t env)
#line 415

#line 415 "bi_msg.m4"
{
#line 415
	
#line 415

#line 415

#line 415
long  nmsg;
#line 415
        
#line 415
get_numeric_arg(env, 0, &nmsg);
#line 415
        
#line 415

#line 415
        adjust_stack(env, 1);
#line 415

#line 415
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 415
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 415

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 420
	
#line 420
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 420
	struct mf_message *mp;
#line 420
			
#line 420
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 420
			env_throw_bi(env, mfe_range, "message_read_body_line", _("Invalid message descriptor"))
#line 420
;
#line 420
	mp = mtab + nmsg;
#line 420
		if (!(mp->msg))
#line 420
			env_throw_bi(env, mfe_failure, "message_read_body_line", _("Message not open"))
#line 420

#line 420
;
#line 420
	if (!mp->body) {
#line 420
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 420
			if (!(rc == 0))
#line 420
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 420
;
#line 420
	}	  
#line 420
;
	
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 423
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 426
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 428
			env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 431
;
		if (!(size > 0))
#line 432
			env_throw_bi(env, mfe_not_found, "message_read_body_line", /* FIXME: Should be mfe_eof */
		  "mu_stream_sequential_getline: %s",_("end of input"))
#line 435
;
	do {pushs(env, mp->buf);
#line 436
return;
#line 436
} while (0);
}
}


#line 440
void
#line 440
msg_init_builtin()
#line 440
{
#line 440
	#line 36 "bi_msg.m4"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs);
#line 136 "bi_msg.m4"
va_builtin_install_ex("message_close", bi_message_close, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 144 "bi_msg.m4"
va_builtin_install_ex("message_size", bi_message_size, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 162 "bi_msg.m4"
va_builtin_install_ex("message_lines", bi_message_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 178 "bi_msg.m4"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 196 "bi_msg.m4"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 215 "bi_msg.m4"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 233 "bi_msg.m4"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 249 "bi_msg.m4"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 265 "bi_msg.m4"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, 0, dtype_number, 3, 1, 0, dtype_number, dtype_string, dtype_number);
#line 278 "bi_msg.m4"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, 0, dtype_string, 3, 1, 0, dtype_number, dtype_string, dtype_number);
#line 298 "bi_msg.m4"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 313 "bi_msg.m4"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 328 "bi_msg.m4"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, 0, dtype_number, 2, 0, 0, dtype_number, dtype_number);
#line 351 "bi_msg.m4"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 370 "bi_msg.m4"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, 0, dtype_string, 1, 0, 0, dtype_number);
#line 396 "bi_msg.m4"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 415 "bi_msg.m4"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, 0, dtype_string, 1, 0, 0, dtype_number);

#line 440 "bi_msg.m4"
		
#line 440
}
#line 580 "../mfd/snarf.m4"

#line 580

